Attribute VB_Name = "FindWindow"
Option Explicit

Public strProcID As String

' diese API wird in der frmFind(lstFoundFiles_DblClick) aufgerufen
Public Declare Function TerminateProcess Lib "kernel32" _
  (ByVal hProcess As Long, ByVal uExitCode As Long) As Long
Public Declare Function GetExitCodeProcess Lib "kernel32" _
  (ByVal hProcess As Long, lpExitCode As Long) As Long

' zunchst die bentigten API-Deklarationen
Private Declare Function CreateToolhelpSnapshot Lib _
  "kernel32" Alias "CreateToolhelp32Snapshot" ( _
  ByVal lFlgas As Long, ByVal lProcessID As Long) _
  As Long
 
Private Declare Function ProcessFirst Lib "kernel32" _
  Alias "Process32First" (ByVal hSnapshot As Long, _
  uProcess As PROCESSENTRY32) As Long
 
Private Declare Function ProcessNext Lib "kernel32" _
  Alias "Process32Next" (ByVal hSnapshot As Long, _
  uProcess As PROCESSENTRY32) As Long
 
Public Declare Function CloseHandle Lib "kernel32" ( _
  ByVal hPass As Long) As Long

Private Const TH32CS_SNAPPROCESS As Long = 2&
Private Const MAX_PATH As Long = 260
 
Private Type PROCESSENTRY32
  dwSize As Long
  cntUsage As Long
  th32ProcessID As Long
  th32DefaultHeapID As Long
  th32ModuleID As Long
  cntThreads As Long
  th32ParentProcessID As Long
  pcPriClassBase As Long
  dwFlags As Long
  szexeFile As String * MAX_PATH
End Type

Public Enum procReturnValue
  Handle = 0
  ProcessID = 1
End Enum

' Fr WinNT4
Private Declare Function EnumProcesses Lib "psapi.dll" ( _
  ByRef lpidProcess As Long, _
  ByVal cb As Long, _
  ByRef cbNeeded As Long) As Long

Public Declare Function OpenProcess Lib "kernel32" ( _
  ByVal dwDesiredAccess As Long, _
  ByVal bInheritHandle As Long, _
  ByVal dwProcessId As Long) As Long
  
Private Declare Function EnumProcessModules Lib "psapi.dll" ( _
  ByVal hProcess As Long, _
  ByRef lphModule As Long, _
  ByVal cb As Long, _
  ByRef lpcbNeeded As Long) As Long
  
Private Declare Function GetModuleFileNameEx Lib "psapi.dll" _
  Alias "GetModuleFileNameExA" ( _
  ByVal hProcess As Long, _
  ByVal hModule As Long, _
  ByVal lpFileName As String, _
  ByVal nSize As Long) As Long

Private Const PROCESS_QUERY_INFORMATION = 1024
Private Const PROCESS_VM_READ = 16

' APIs, um die Windows-Version abzufragen
Private Type OSVERSIONINFO
  dwOSVersionInfoSize As Long
  dwMajorVersion As Long
  dwMinorVersion As Long
  dwBuildNumber As Long
  dwPlatformID As Long
  szCSDVersion As String * 128
End Type

Private Declare Function GetVersionEx Lib "kernel32" _
  Alias "GetVersionExA" _
  (ByRef lpVersionInformation As OSVERSIONINFO) As Long
  
Private Const VER_PLATFORM_WIN32_NT = 2
Private Const VER_PLATFORM_WIN32_WINDOWS = 1
Private Const GW_HWNDNEXT = 2

' weitere API-Deklarationen
Public Declare Function GetWindowThreadProcessId Lib _
  "user32" (ByVal hwnd As Long, lpdwProcessId As Long) _
  As Long

Private Declare Function FindWindow Lib "user32" _
  Alias "FindWindowA" (ByVal lpClassName As String, _
  ByVal lpWindowName As String) As Long

Private Declare Function GetWindow Lib "user32" ( _
  ByVal hwnd As Long, ByVal wCmd As Long) As Long
        
' bringt ein Fenster an die oberste Position im Fensterstapel
' und legt es auf anderen berlappenden Fenster auf dem Bildschirm ab.
Private Declare Function BringWindowToTop Lib "user32" (ByVal _
      hwnd As Long) As Long
      
' bringt den Thread, der das vorgegebene Fenster erzeugt hat,
' in den Vordergrund und aktiviert das Fenster.
Private Declare Function SetForegroundWindow Lib "user32" ( _
      ByVal hwnd As Long) As Long

' EnumWindows ermittelt alle laufenden Anwendungen.
' EnumWindows ruft eine von der Anwendung definierte
' Callback-Funktion fr alle Top-Level-Fenster auf.
Public Declare Function EnumWindows Lib "user32" (ByVal _
      lpEnumFunc As Long, ByVal lParam As Long) As Long

' Mit EnumChildWindows werden alle abgeleiteten Fenster (Kindfenster) sequentiell abgearbeitet.
' EnumChildWindows sendet den Handle jedes abgeleiteten Fensters (Kindfenster),
' das zu einem Stammfenster (Elternfenster) gehrt, an eine Callback-Funktion.
Public Declare Function EnumChildWindows Lib "user32" ( _
      ByVal hWndParent As Long, ByVal lpEnumFunc As Long, _
      ByVal lParam As Long) As Long

' ermittelt den Klassennamen, mit dem das vorgegebene Fenster erzeugt wurde.
Private Declare Function GetClassName Lib "user32" Alias _
      "GetClassNameA" (ByVal hwnd As Long, ByVal lpClassName _
      As String, ByVal nMaxCount As Long) As Long

' ermittelt die Lnge eines Fenstertitels oder des Textes in einem Steuerelement.
Private Declare Function GetWindowTextLength Lib "user32" _
      Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long

' ermittelt den Titel von Stamm-, PopUp- und abgeleiteten Fenstern oder den Text
' aus einem Steuerelement, wie beispielsweise einer Schaltflche oder einem Bearbeitungsfeld.
Private Declare Function GetWindowText Lib "user32" Alias _
      "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString _
      As String, ByVal cch As Long) As Long

' ermittelt den Handle fr das Fenster, dem das aktuelle Fenster angehrt.
Private Declare Function GetParent Lib "user32" ( _
      ByVal hwnd As Long) As Long

' ermittelt, ob ein Fenster sichtbar oder verborgen ist.
Public Declare Function IsWindowVisible Lib "user32" ( _
      ByVal hwnd As Long) As Long

' ermittelt 32-Bit-(Long-)Werte aus den Informationen, die ber das vorgegebene Fenster gespeichert sind.
Private Declare Function GetWindowLong Lib "user32" Alias _
      "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex _
      As Long) As Long

' ermittelt, ob ein Fenster minimiert ist.
Private Declare Function IsIconic Lib "user32" (ByVal hwnd As Long) As Long

' setzt den Anzeigestatus eines Fensters.
Private Declare Function ShowWindow Lib "user32" (ByVal hwnd _
      As Long, ByVal nCmdShow As Long) As Long

Private Const GWL_HWNDPARENT = (-8)
Private Const GWL_STYLE = (-16)

Private Const WS_VISIBLE = &H10000000
Private Const WS_BORDER = &H800000

Private Const SW_SHOW = 5
Private Const SW_RESTORE = 9

Public Sub AddWndInfosToListView(ByVal hwnd As Long, ByVal _
      lParam As Long, ByVal lvw As ListView)
'Fenster-Titel, -Handle und -Klassenname ermitteln und
'zum ListView-Steuerelement hinzufgen
  
  Dim nRetVal       As Long
  Dim Task            As Long
  Dim Result          As Long
  Dim hModule      As Long
  Dim FileName    As String
  Dim strClassName  As String
  Dim strWndTitle   As String

  Dim itmX          As ListItem
    
  'Klassenname (Class Name) ermitteln
    strClassName = Space$(64)
    nRetVal = GetClassName(hwnd, strClassName, Len(strClassName))
    strClassName = Left$(strClassName, nRetVal)
  
  'Fenster-Titel ermitteln
    nRetVal = GetWindowTextLength(hwnd)
    strWndTitle = Space$(nRetVal)
    If nRetVal <> 0 Then
        'If nRetVal > 256 Then nRetVal = 255
        strWndTitle = Space$(nRetVal + 1)
        GetWindowText hwnd, strWndTitle, Len(strWndTitle)
        strWndTitle = Left$(strWndTitle, nRetVal)
    End If
    'Task Id ermitteln
    Result = GetWindowThreadProcessId(hwnd, Task)
    
  Select Case lvw.Name
  Case "lvwTopLevelWnd"
    'Je nach Option entweder nur sichtbare Fenster
    'oder alle Fenster zum ListView-Steuerelement hinzufgen
      If Len(strWndTitle) > 0 Or lParam <> 0 Then
          ' ProzessID noch auslesen
          Set itmX = lvw.ListItems.Add(Text:=Format$(Task, "000"), Key:=CStr(hwnd) & "h")
        'Fenster-Titel
          itmX.SubItems(1) = strWndTitle
       'Fenster-Handle
          itmX.SubItems(2) = CStr(hwnd)
        'Klassenname
          itmX.SubItems(3) = strClassName
      End If
    Case "lvwChildWnd"
    'Je nach Option entweder nur sichtbare Fenster
    'oder alle Fenster zum ListView-Steuerelement hinzufgen
      If Len(strWndTitle) > 0 Or lParam <> 0 Then
        'Fenster-Titel
        Set itmX = lvw.ListItems.Add(Text:=strWndTitle, Key:=CStr(hwnd) & "h")
        'Fenster-Handle
          itmX.SubItems(1) = CStr(hwnd)
        'Klassenname
          itmX.SubItems(2) = strClassName
      End If
    End Select
End Sub
Public Function EnumChildProc(ByVal hwnd As Long, ByVal lParam As Long) As Long
'"Kind"-Fenster ermitteln und zum ListView-Steuerelement hinzufgen
  Dim nStyle As Long
  
  Select Case lParam
      Case 0  'Nur sichtbare Fenster mit Titel und Rahmen anzeigen
          nStyle = GetWindowLong(hwnd, GWL_STYLE)
          nStyle = nStyle And (WS_VISIBLE Or WS_BORDER)
          If (nStyle = (WS_VISIBLE Or WS_BORDER)) Then
            'Zum ListView-Steuerelement hinzufgen
              AddWndInfosToListView hwnd, lParam, frmFind.lvwChildWnd
          End If
      Case 1  'Alle Fenster mit Titel anzeigen
          lParam = 0
        'Zum ListView-Steuerelement hinzufgen
          AddWndInfosToListView hwnd, lParam, frmFind.lvwChildWnd
      Case 2  'Alle Fenster anzeigen
        'Zum ListView-Steuerelement hinzufgen
          AddWndInfosToListView hwnd, lParam, frmFind.lvwChildWnd
      Case Else
  End Select
  
  EnumChildProc = True
End Function
Public Function EnumWinProc(ByVal hwnd As Long, ByVal lParam As Long) As Long
'Stammfenster ermitteln, je nachdem welcher Wert fr lParam bergeben wurde,
'a l l e  Top-Level-Fenster oder nur die sichtbaren Fenster
    If (IsWindowVisible(hwnd) Or lParam) Then
        If GetParent(hwnd) = 0 Then
            If GetWindowLong(hwnd, GWL_HWNDPARENT) = 0 Then
                'zum ListView-Steuerelement hinzufgen
                  AddWndInfosToListView hwnd, lParam, frmFind.lvwTopLevelWnd
            End If
        End If
    End If
    
    EnumWinProc = True
End Function
Public Function BringWndToTop(ByVal hwnd As Long) As Long
  'Fenster in den Vordergrund bringen
    If IsWindowVisible(hwnd) Then
        If IsIconic(hwnd) Then
            ShowWindow hwnd, SW_RESTORE
        Else
            ShowWindow hwnd, SW_SHOW
        End If
        DoEvents
        BringWindowToTop hwnd
        SetForegroundWindow hwnd
    End If
End Function
' Prft, ob eine EXE-Datei bereits ausgefhrt wird und gibt im Erfolgsfall entweder
' das Fensterhandle oder die Process-ID zurck
Public Function IsEXERunning(ByVal sFilename As String, _
  Optional ByVal iReturn As procReturnValue = ProcessID) As Long
  Dim entry As String
  Dim nResult As Long
  
  ' Je nach System...
  If IsWinNT() Then
    ' NT4 - Sonderbehandlung :-)
    
    Dim lCb As Long
    Dim lCbNeeded As Long
    Dim lCbNeeded2 As Long
    Dim lProcID() As Long
    Dim lModules(1 To 200) As Long
    Dim hProcess As Long
    Dim sModuleName As String
    Dim n As Long
    
    ' alle laufenden Prozesse ermitteln
    lCb = 8: lCbNeeded = 96
    Do While lCb <= lCbNeeded
       lCb = lCb * 2
       ReDim lProcID(lCb / 4) As Long
       EnumProcesses lProcID(1), lCb, lCbNeeded
    Loop
    
    For n = 1 To lCbNeeded / 4
       ' Prozess-Handle ermitteln
       hProcess = OpenProcess(PROCESS_QUERY_INFORMATION _
          Or PROCESS_VM_READ, 0, lProcID(n))
       If hProcess <> 0 Then
         nResult = EnumProcessModules(hProcess, lModules(1), 200, lCbNeeded2)
         If nResult <> 0 Then
           sModuleName = Space(MAX_PATH)
           nResult = GetModuleFileNameEx(hProcess, _
              lModules(1), sModuleName, Len(sModuleName))
           sModuleName = LCase$(Left$(sModuleName, nResult))
            
           ' Zeile in TextBox ausgeben
           If Len(CStr(ProcID2hWnd(lProcID(n)))) > 7 Then
             entry = lProcID(n) & Chr$(9) & ProcID2hWnd(lProcID(n)) & Chr$(9) & sModuleName
           Else
             entry = lProcID(n) & Chr$(9) & ProcID2hWnd(lProcID(n)) & Chr$(9) & Chr$(9) & sModuleName
           End If
          
           ' sModuleName beinhaltet den kompletten Pfad!
           If Right$(sModuleName, Len(sFilename) + 1) = "\" + LCase$(sFilename) Then
             ' Jepp - EXE gefunden!
             If iReturn = Handle Then
               IsEXERunning = ProcID2hWnd(lProcID(n))
             Else
               IsEXERunning = lProcID(n)
             End If
           End If
         End If
       End If
       CloseHandle hProcess
    Next n
    
  Else
    ' bei allen anderen Systemen...
    Dim lSnapshot As Long
    Dim uProcess As PROCESSENTRY32
  
    ' "Snapshot" des aktuellen Prozess ermitteln
    lSnapshot = CreateToolhelpSnapshot(TH32CS_SNAPPROCESS, 0&)
    If lSnapshot <> 0 Then
      uProcess.dwSize = Len(uProcess)
      
      ' Ersten Prozess ermitteln
      nResult = ProcessFirst(lSnapshot, uProcess)
      
      Do Until nResult = 0
        ' Prozessliste durchlaufen
        If InStr(LCase$(uProcess.szexeFile), sFilename) > 0 Then
          MsgBox "EXE gefunden"
          If iReturn = Handle Then
            IsEXERunning = ProcID2hWnd(uProcess.th32ProcessID)
          Else
            IsEXERunning = uProcess.th32ProcessID
          End If
          Exit Do
        End If
        
        ' nchster Prozess
        nResult = ProcessNext(lSnapshot, uProcess)
      Loop
      
      ' Handle schliessen
      CloseHandle lSnapshot
    End If
  End If
End Function
' Prft, ob eine EXE-Datei bereits ausgefhrt wird und gibt im Erfolgsfall entweder
' das Fensterhandle oder die Process-ID zurck
Public Function AppName(ProcessID) As String
  Dim entry As String
  Dim nResult As Long
  
  ' Je nach System...
'  If IsWinNT() Then
    ' NT4 - Sonderbehandlung :-)
    
    Dim lCb As Long
    Dim lCbNeeded As Long
    Dim lCbNeeded2 As Long
    Dim lProcID() As Long
    Dim lModules(1 To 200) As Long
    Dim hProcess As Long
    Dim sModuleName As String
    Dim n As Long
    
    ' alle laufenden Prozesse ermitteln
    lCb = 8: lCbNeeded = 96
    Do While lCb <= lCbNeeded
       lCb = lCb * 2
       ReDim lProcID(lCb / 4) As Long
       EnumProcesses lProcID(1), lCb, lCbNeeded
    Loop
    
  For n = 1 To lCbNeeded / 4
    ' FileName ermitteln
    hProcess = OpenProcess(PROCESS_QUERY_INFORMATION _
       Or PROCESS_VM_READ, 0, lProcID(n))
      If lProcID(n) = Val(ProcessID) Then
        If hProcess <> 0 Then
          nResult = EnumProcessModules(hProcess, lModules(1), 200, lCbNeeded2)
          If nResult <> 0 Then
            sModuleName = Space(MAX_PATH)
            nResult = GetModuleFileNameEx(hProcess, _
               lModules(1), sModuleName, Len(sModuleName))
            ' sModuleName beinhaltet den kompletten Pfad!
            AppName = UCase$(Left$(sModuleName, nResult))
          End If
        Else
          AppName = "System"
      End If
    End If
    CloseHandle hProcess
  Next n
    
End Function

' Windows NT?
Public Function IsWinNT() As Boolean
  Dim OSVersion As OSVERSIONINFO
  
  With OSVersion
    .dwOSVersionInfoSize = Len(OSVersion)
    GetVersionEx OSVersion

    IsWinNT = (.dwPlatformID = VER_PLATFORM_WIN32_NT) And (.dwMajorVersion <= 4)
  End With
End Function
' Ermittelt das Fensterhandle anhand einer Prozess-ID
Public Function ProcID2hWnd(ByVal ProcID As Long) As Long
  ' alle Fenster durchlaufen und nach Process-ID suchen
  Dim lnghWnd As Long
  Dim lngProcTaskID As Long
  
  lnghWnd = FindWindow(vbNullString, vbNullString)
  Do While lnghWnd <> 0
    
    ' Existiert kein Eltern-Fenster, dann ProcssID
    ' ermitteln und mit TaskID vergleichen
    If GetParent(lnghWnd) = 0 Then
      GetWindowThreadProcessId lnghWnd, lngProcTaskID
      
      ' Handelt es sich um die gesuchte TaskID?
      If lngProcTaskID = ProcID Then
        ' Fenster-Handle zurckgeben und Schleife verlassen!
        ProcID2hWnd = lnghWnd
        Exit Do
      End If
    End If
    
    ' Nchstes Fenster
    lnghWnd = GetWindow(lnghWnd, GW_HWNDNEXT)
  Loop
End Function
