VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "KeepDir"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Speichert das jeweils aktuelle Verzeichnis einer DirListBox zur Wiederherstellung nach Drive-Wechsel in DriveListBox"
Option Explicit

' *** Den Artikel zu diesem Modul finden Sie unter http://www.aboutvb.de/kom/artikel/komkeepdir.htm ***

Public Event DirChange()
Public Event DirClick()
Public Event DriveChange()
Public Event OnError(ByVal ErrNumber As Long, RestoreLastDrive As Boolean)

Private Enum EventConstants
    kEventNone = 0
    kEventDriveChange = 1
    kEventDirChange = 2
    kEventDirClick = 4
End Enum

Private WithEvents eDirListBox As DirListBox
Attribute eDirListBox.VB_VarHelpID = -1
Private WithEvents eDriveListBox As DriveListBox
Attribute eDriveListBox.VB_VarHelpID = -1

Private mEvents As EventConstants
Private mKeepDirs As Collection
Private mLastDrive As String
Public Sub Init(DriveListBox As DriveListBox, DirListBox As DirListBox)
Attribute Init.VB_Description = "Initialisiert Objekt und assoziiert DriveListBox und DirListBox"
    Set eDriveListBox = DriveListBox
    Set eDirListBox = DirListBox
    mLastDrive = Left$(eDriveListBox.Drive, 2)
    mKeepDirs.Add eDirListBox.Path, mLastDrive
End Sub
Private Sub Class_Initialize()
    Set mKeepDirs = New Collection
End Sub
Private Sub Class_Terminate()
    Set mKeepDirs = Nothing
    Set eDirListBox = Nothing
    Set eDriveListBox = Nothing
End Sub
Private Sub eDirListBox_Change()
    Dim nDrive As String
   
    With eDirListBox
        nDrive = Left$(.Path, 2)
        On Error Resume Next
        mKeepDirs.Remove nDrive
        On Error GoTo 0
        mKeepDirs.Add Array(.Path, .ListIndex), nDrive
        If mEvents Then
            mEvents = mEvents Or kEventDirChange
        Else
            RaiseEvent DirChange
        End If
    End With
End Sub
Private Sub eDirListBox_Click()
    Dim nDrive As String
    
    With eDirListBox
        nDrive = Left$(.Path, 2)
        On Error Resume Next
        mKeepDirs.Remove nDrive
        On Error GoTo 0
        mKeepDirs.Add Array(.Path, .ListIndex), nDrive
        If mEvents Then
            mEvents = mEvents Or kEventDirClick
        Else
            RaiseEvent DirClick
        End If
    End With
End Sub
Private Sub eDriveListBox_Change()
    Dim I As Integer
    Dim nErrNum As Long
    Dim nDrive As String
    Dim nRestoreLastDrive As Boolean
    Dim nRestore As Variant
    
    Static sInProc As Boolean
        
    If sInProc Then
        Exit Sub
    Else
        sInProc = True
    End If
    mEvents = kEventDriveChange
    nDrive = Left$(eDriveListBox.Drive, 2)
    On Error Resume Next
    nRestore = mKeepDirs(nDrive)
    With eDirListBox
        .Path = CStr(nRestore(0))
        If Err.Number Then
            Err.Clear
            .Path = nDrive
            If Err.Number Then
                nErrNum = Err.Number
                On Error GoTo 0
                nRestoreLastDrive = True
                RaiseEvent OnError(nErrNum, nRestoreLastDrive)
                If nRestoreLastDrive Then
                    nDrive = mLastDrive
                    eDriveListBox.Drive = nDrive
                    mEvents = kEventNone
                End If
                sInProc = False
                Exit Sub
            End If
        Else
            .ListIndex = CStr(nRestore(1))
        End If
    End With
    mLastDrive = nDrive
    If (mEvents And kEventDriveChange) = kEventDriveChange Then
        RaiseEvent DriveChange
    End If
    If (mEvents And kEventDirChange) = kEventDirChange Then
        RaiseEvent DirChange
    End If
    If (mEvents And kEventDirClick) = kEventDirClick Then
        RaiseEvent DirClick
    End If
    mEvents = kEventNone
    sInProc = False
End Sub
