Attribute VB_Name = "MCmdOutput"
Option Explicit

Private Const STARTF_USESHOWWINDOW = &H1
Private Const STARTF_USESTDHANDLES = &H100
Private Const SW_HIDE = 0
Private Const DUPLICATE_CLOSE_SOURCE = &H1
Private Const DUPLICATE_SAME_ACCESS = &H2

Private Const ERROR_BROKEN_PIPE = 109

Public Type SECURITY_ATTRIBUTES
  nLength As Long
  lpSecurityDescriptor As Long
  bInheritHandle As Long
End Type

Private Type STARTUPINFO
  cb As Long
  lpReserved As String
  lpDesktop As String
  lpTitle As String
  dwX As Long
  dwY As Long
  dwXSize As Long
  dwYSize As Long
  dwXCountChars As Long
  dwYCountChars As Long
  dwFillAttribute As Long
  dwFlags As Long
  wShowWindow As Integer
  cbReserved2 As Integer
  lpReserved2 As Long
  hStdInput As Long
  hStdOutput As Long
  hStdError As Long
End Type

Private Type PROCESS_INFORMATION
  hProcess As Long
  hThread As Long
  dwProcessId As Long
  dwThreadId As Long
End Type

Private Declare Function CreatePipe Lib "kernel32" ( _
  phReadPipe As Long, phWritePipe As Long, _
  lpPipeAttributes As Any, ByVal nSize As Long) As Long

Private Declare Function ReadFile Lib "kernel32" ( _
  ByVal hFile As Long, lpBuffer As Any, _
  ByVal nNumberOfBytesToRead As Long, _
  lpNumberOfBytesRead As Long, _
  lpOverlapped As Any) As Long

Private Declare Function WriteFile Lib "kernel32" ( _
  ByVal hFile As Long, lpBuffer As Any, _
  ByVal nNumberOfBytesToWrite As Long, _
  lpNumberOfBytesWritten As Long, _
  lpOverlapped As Any) As Long

Private Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" ( _
  ByVal lpApplicationName As String, ByVal lpCommandLine As String, _
  lpProcessAttributes As Any, lpThreadAttributes As Any, _
  ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, _
  lpEnvironment As Any, ByVal lpCurrentDriectory As String, _
  lpStartupInfo As STARTUPINFO, _
  lpProcessInformation As PROCESS_INFORMATION) As Long

Private Declare Function GetCurrentProcess Lib "kernel32" () As Long

Private Declare Function DuplicateHandle Lib "kernel32" ( _
  ByVal hSourceProcessHandle As Long, _
  ByVal hSourceHandle As Long, _
  ByVal hTargetProcessHandle As Long, _
  lpTargetHandle As Long, _
  ByVal dwDesiredAccess As Long, _
  ByVal bInheritHandle As Long, _
  ByVal dwOptions As Long) As Long

Private Declare Function OemToCharBuff Lib "user32" Alias "OemToCharBuffA" ( _
  lpszSrc As Any, _
  ByVal lpszDst As String, _
  ByVal cchDstLength As Long) As Long

Type DCB
        DCBlength As Long
        BaudRate As Long
        fBitFields As Long 'See Comments in Win32API.Txt
        wReserved As Integer
        XonLim As Integer
        XoffLim As Integer
        ByteSize As Byte
        Parity As Byte
        StopBits As Byte
        XonChar As Byte
        XoffChar As Byte
        ErrorChar As Byte
        EofChar As Byte
        EvtChar As Byte
        wReserved1 As Integer 'Reserved; Do Not Use
End Type

Type COMMCONFIG
    dwSize As Long
    wVersion As Integer
    wReserved As Integer
    dcbx As DCB
    dwProviderSubType As Long
    dwProviderOffset As Long
    dwProviderSize As Long
    wcProviderData As Byte
End Type
'
Public Declare Function GetDefaultCommConfig Lib "kernel32" Alias _
  "GetDefaultCommConfigA" (ByVal lpszName As String, _
  lpCC As COMMCONFIG, lpdwSize As Long) As Long

'Public Declare Function CommConfigDialog Lib "kernel32" Alias _
'  "CommConfigDialogA" (ByVal lpszName As String, ByVal hwnd As Long, _
'  lpCC As COMMCONFIG) As Long
' Diese Function ist fr die Kommunikation zustndig
Public Function GetCommandOutput(sCommandLine As String, Optional fStdOut As Boolean = True, _
                                 Optional fStdErr As Boolean = False, Optional fOEMConvert As Boolean = True) As String
'*********************************************************************************************************************
' sCommandLine:  [in] Eingabezeile
' fStdOut                  [in,opt] True (default) erfassen der Ausgabe STDOUT
' fStdErr                   [in,opt] True erfassen der Ausgabe STDERR. False ist default.
' fOEMConvert:       [in,opt] True (default) umwandeln von DOS Zeichen nach Windows, False ohne Umwandlung
'
' Rckgabe:       String mit STDOUT und/oder STDERR Wert
'*********************************************************************************************************************
  Dim lRet As Long
  Dim hPipeRead As Long
  Dim hPipeRead3 As Long
  Dim hPipeWrite1 As Long
  Dim hPipeWrite2 As Long
  Dim hPipeWrite3 As Long
  Dim hCurProcess As Long
  Dim baOutput() As Byte
  Dim sNewOutput As String
  Dim lBytesRead As Long
  Dim fTwoHandles As Boolean
  Dim start As STARTUPINFO
  Dim proc As PROCESS_INFORMATION
  Dim sa As SECURITY_ATTRIBUTES
  
  Const BUFSIZE = 1024      ' pipe buffer size
  
  If (Not fStdOut) And (Not fStdErr) Then Err.Raise 5   ' Invalid Procedure call or Argument
  
  ' liefern beide True zurck, nutzen wir 2 write Handles. Falls nicht, ist eins genug.
  fTwoHandles = fStdOut And fStdErr
  
  ReDim baOutput(BUFSIZE - 1) As Byte

  With sa
    .nLength = Len(sa)
    .bInheritHandle = 1
  End With
  
  If CreatePipe(hPipeRead, hPipeWrite1, sa, BUFSIZE) = 0 Then Exit Function
  
  hCurProcess = GetCurrentProcess()
  
  ' Replace our inheritable read handle with an non-inheritable. Not that it
  ' seems to be necessary in this case, but the docs say we should.
  Call DuplicateHandle(hCurProcess, hPipeRead, hCurProcess, hPipeRead, 0&, _
                       0&, DUPLICATE_SAME_ACCESS Or DUPLICATE_CLOSE_SOURCE)
  
  ' Ist STDOUT und STDERR dann wird umgeleitet, auf ein extra Handle.
  If fTwoHandles Then
    Call DuplicateHandle(hCurProcess, hPipeWrite1, hCurProcess, hPipeWrite2, 0&, _
                         1&, DUPLICATE_SAME_ACCESS)
  End If
  
  With start
    .cb = Len(start)
    .dwFlags = STARTF_USESHOWWINDOW Or STARTF_USESTDHANDLES
    .wShowWindow = SW_HIDE          ' versteckt das Fenster
    
    If fTwoHandles Then
      .hStdOutput = hPipeWrite1
      .hStdError = hPipeWrite2
    ElseIf fStdOut Then
      .hStdOutput = hPipeWrite1
    Else
      .hStdError = hPipeWrite1
    End If
  End With
  
  If CreatePipe(hPipeWrite3, hPipeRead3, sa, BUFSIZE) = 0 Then Exit Function
  start.hStdInput = hPipeWrite3
  
  ' Das Handle des Leseende der Pipe wird geschlossen
  Call CloseHandle(hPipeRead3)
  hPipeRead3 = 0
    
  If CreateProcess(vbNullString, sCommandLine, ByVal 0&, ByVal 0&, 1, 0&, _
                   ByVal 0&, vbNullString, start, proc) Then
    
    ' Schliet das Handle des Thread  - wird nicht gebraucht
    Call CloseHandle(proc.hThread)
    
    ' Hier werden alle Handle(s) des writeendes der Pipe geschlossen.
    ' This is important, since ReadFile will *not* return until all write handles
    ' are closed or the buffer is full.
    Call CloseHandle(hPipeWrite1)
    hPipeWrite1 = 0
    If hPipeWrite2 Then
      Call CloseHandle(hPipeWrite2)
      hPipeWrite2 = 0
    End If
  
    Do
      ' Add a DoEvents to allow more data to be written to the buffer for
      ' each call. This results in fewer, larger chunks to be read.
      'DoEvents
      
      If ReadFile(hPipeRead, baOutput(0), BUFSIZE, lBytesRead, ByVal 0&) = 0 Then Exit Do
      
      If fOEMConvert Then
        ' umwandeln von "DOS" nach "Windows" Zeichen
        sNewOutput = String$(lBytesRead, 0)
        Call OemToCharBuff(baOutput(0), sNewOutput, lBytesRead)
      Else
        ' ohne Umwandlung (Unicode)
        sNewOutput = Left$(StrConv(baOutput(), vbUnicode), lBytesRead)
      End If
      GetCommandOutput = GetCommandOutput & sNewOutput
      ' If you are executing an application that outputs data during a
      ' long time, and don't want to lock up your application, it might
      ' be a better idea to wrap this code in a class module in an
      ' ActiveX EXE and execute it asynchronously.
      ' Then you can raise an event here each time more data is available.
      'RaiseEvent OutputAvailabele(sNewOutput)
    Loop
    
    ' When the process terminates successfully, Err.LastDllError will be
    ' ERROR_BROKEN_PIPE (109). Other values indicates an error.
    Call CloseHandle(proc.hProcess)
    
  End If
  
  ' Alle noch offenen Handles schlieen
  Call CloseHandle(hPipeRead)
  If hPipeWrite1 Then Call CloseHandle(hPipeWrite1)
  If hPipeWrite2 Then Call CloseHandle(hPipeWrite2)
  
End Function
Public Function EnumSerPorts(Port As Integer) As Long
  ' Diese Funktion wird von mnuCOM_Click aus aufgerufen
  Dim cc As COMMCONFIG, ccsize As Long
  Dim I As Integer, ret As Integer

  ccsize = LenB(cc)     'gets the size of COMMCONFIG structure
  EnumSerPorts = GetDefaultCommConfig("COM" + Trim(Str(Port)) + Chr(0), cc, ccsize)
  Select Case Port
  Case 1
    If EnumSerPorts <> 0 Then
        frmPorts.List1.AddItem "COM1:"
    End If
  Case 2
    If EnumSerPorts <> 0 Then
        frmPorts.List1.AddItem "COM2:"
    End If
  Case 3
    If EnumSerPorts <> 0 Then
        frmPorts.List1.AddItem "COM3:"
    End If
  Case 4
    If EnumSerPorts <> 0 Then
        frmPorts.List1.AddItem "COM4:"
    End If
  Case 5
    If EnumSerPorts <> 0 Then
        frmPorts.List1.AddItem "COM5:"
    End If
  Case 6
    If EnumSerPorts <> 0 Then
        frmPorts.List1.AddItem "COM6:"
    End If
  Case 7
    If EnumSerPorts <> 0 Then
        frmPorts.List1.AddItem "COM7:"
    End If
  Case 8
    If EnumSerPorts <> 0 Then
        frmPorts.List1.AddItem "COM8:"
    End If
    Case 9
    If EnumSerPorts <> 0 Then
        frmPorts.List1.AddItem "COM9:"
    End If
  End Select
  
End Function
