Attribute VB_Name = "mOCXDLL"
Option Explicit

' Registry-Schssel
Public Const HKEY_CLASSES_ROOT = &H80000000

' Rckgabewerte
' Unicode nul terminated string
Public Const REG_SZ = 1
' The configuration registry database operation completed successfully.
Public Const ERROR_SUCCESS = 0&
'   The system cannot find the file specified.
Public Const ERROR_FILE_NOT_FOUND = 2&
'   The handle is invalid.
Public Const ERROR_INVALID_HANDLE = 6&

'The Maximum data length
Public Const MAX_LENGTH As Long = 2048

Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

' API-Deklarationen
Public Declare Function RegOpenKey Lib "advapi32.dll" _
  Alias "RegOpenKeyA" (ByVal hKey As Long, _
  ByVal lpSubKey As String, phkResult As Long) As Long

Public Declare Function RegCloseKey Lib "advapi32.dll" _
  (ByVal hKey As Long) As Long

Public Declare Function RegEnumKey Lib "advapi32.dll" _
  Alias "RegEnumKeyA" (ByVal hKey As Long, _
  ByVal dwIndex As Long, ByVal lpName As String, _
  ByVal cbName As Long) As Long

Public Declare Function RegQueryValueEx Lib "advapi32.dll" _
  Alias "RegQueryValueExA" (ByVal hKey As Long, _
  ByVal lpValueName As String, ByVal lpReserved As Long, _
  lpType As Long, lpData As Any, lpcbData As Long) As Long
' Alle untergeordneten Registry-Schlssel eines anderen
' Schlssels auslesen (Rckgabe ist ein Array)
Public Function GetAllKeys(hKey As Long, strPath As String) As Variant
  Dim lRegResult As Long
  Dim lCounter As Long
  Dim hCurKey As Long
  Dim strBuffer As String
  Dim lDataBufferSize As Long
  Dim strNames() As String
  Dim intZeroPos As Integer
  Dim Result As Long
  Dim dwType As Long
  Dim cbMaxSubKeyLen As Long
   
  lCounter = 0
  ' The RegOpenKey function opens the specified key
  lRegResult = RegOpenKey(hKey, strPath, hCurKey)
  Do
    lDataBufferSize = 255
    strBuffer = String(lDataBufferSize, " ")
    ' The RegEnumKey function enumerates subkeys of the specified open registry key
    lRegResult = RegEnumKey(hCurKey, lCounter, strBuffer, lDataBufferSize)
    If lRegResult = ERROR_SUCCESS Then
      ReDim Preserve strNames(lCounter) As String
      intZeroPos = InStr(strBuffer, Chr$(0))
      If intZeroPos > 0 Then
        strNames(UBound(strNames)) = Left$(strBuffer, intZeroPos - 1)
      Else
        strNames(UBound(strNames)) = strBuffer
      End If
      lCounter = lCounter + 1
    Else
      Exit Do
    End If
  Loop
  GetAllKeys = strNames
End Function
' Untereintrag in der Registry auslesen
Public Function GetSettingPath(hKey As Long, strPath As String, lpValueName As String, _
  Optional Default As String) As String
  Dim hCurKey As Long
  Dim lpType As Long
  Dim strBuffer As String
  Dim lDataBufferSize As Long
  Dim intZeroPos As Integer
  Dim lRegResult As Long
  Dim strPathTemp As String
   
  If Not IsEmpty(Default) Then
    GetSettingPath = Default
  Else
    GetSettingPath = ""
  End If
  ' The RegOpenKey function opens the specified key
  strPathTemp = strPath & "\0\win32"
  lRegResult = RegOpenKey(hKey, strPathTemp, hCurKey)
  If lRegResult = ERROR_FILE_NOT_FOUND Then
    ' Falls kein Eintrag gefunden wurde, auf weitere Varianten prfen
    strPathTemp = strPath & "\9\win32"
    lRegResult = RegOpenKey(hKey, strPathTemp, hCurKey)
    If lRegResult = ERROR_FILE_NOT_FOUND Then
      strPathTemp = strPath & "\409\win32"
      lRegResult = RegOpenKey(hKey, strPathTemp, hCurKey)
    End If
  End If
  
  ' The RegQueryValueEx function retrieves the type and data for a specified value name associated with an open registry key
  lRegResult = RegQueryValueEx(hCurKey, lpValueName, 0&, lpType, ByVal 0&, lDataBufferSize)
  If lRegResult = ERROR_SUCCESS Then
    If lpType = REG_SZ Then
      strBuffer = String(lDataBufferSize, " ")
      lRegResult = RegQueryValueEx(hCurKey, lpValueName, 0&, 0&, ByVal strBuffer, lDataBufferSize)
      intZeroPos = InStr(strBuffer, Chr$(0))
      If intZeroPos > 0 Then
        GetSettingPath = Left$(strBuffer, intZeroPos - 1)
      Else
        GetSettingPath = strBuffer
      End If
    End If
  Else
     'Fehler
  End If
  ' The RegCloseKey function releases a handle to the specified key
  lRegResult = RegCloseKey(hCurKey)
End Function

' Registry-Eintrag auslesen
Public Function GetSettingString(hKey As Long, strPath As String, lpValueName As String, _
  Optional Default As String) As String
  Dim hCurKey As Long
  Dim lpType As Long
  Dim strBuffer As String
  Dim lDataBufferSize As Long
  Dim intZeroPos As Integer
  Dim lRegResult As Long
   
  If Not IsEmpty(Default) Then
    GetSettingString = Default
  Else
    GetSettingString = ""
  End If
  ' The RegOpenKey function opens the specified key
  lRegResult = RegOpenKey(hKey, strPath, hCurKey)
  ' The RegQueryValueEx function retrieves the type and data for a specified value name associated with an open registry key
  lRegResult = RegQueryValueEx(hCurKey, lpValueName, 0&, lpType, ByVal 0&, lDataBufferSize)
  If lRegResult = ERROR_SUCCESS Then
    If lpType = REG_SZ Then
      strBuffer = String(lDataBufferSize, " ")
      lRegResult = RegQueryValueEx(hCurKey, lpValueName, 0&, 0&, ByVal strBuffer, lDataBufferSize)
      intZeroPos = InStr(strBuffer, Chr$(0))
      If intZeroPos > 0 Then
        GetSettingString = Left$(strBuffer, intZeroPos - 1)
      Else
        GetSettingString = strBuffer
      End If
    End If
  Else
     'Fehler
  End If
  ' The RegCloseKey function releases a handle to the specified key
  lRegResult = RegCloseKey(hCurKey)
End Function
